public class Node {
	public Object data;
	public Node next;

    /*:
      public ghost specvar con :: objset = "{} :: objset";

      public ensured invariant ConAlloc: "con \<subseteq> Object.alloc";

      public invariant ConNull: "this = null --> con = {}";
      public invariant ConDef: "this ~= null --> 
         con = {this..data} Un next..con & 
         data ~: next..con";
    */


	public Node test2(Object a)
	/*:
	  ensures "result..con = {a}";
	 */
	{
		Node tmp = new Node();
		tmp.data = a;
		tmp.next = null;
		//: "tmp..con" := "{a}";
		return tmp;
	}

	public void test(Object a)
	/*:
	  requires "a ~= null"
	  modifies "this..Node.con"
	  ensures "this..Node.con = {a}";
	 */
	{
		this.data = a;
		//: "this..Node.con" := "(old this..Node.con \<setminus> {old this..Node.data}) Un {a}";
		this.next = null;
		//: "this..Node.con" := "{a}";
	}

	public void test1(Node p)
	/*:
	  requires "this..Node.data ~: p..Node.con"
	  modifies "this..Node.next"
	  ensures "this..Node.next = p";
	 */
	{
		this.next = p;
		// "this..Node.next" := "p";
		//: "this..Node.con" := "{this..Node.data} Un p..Node.con";
	}

	public void test4(Object a)
	/*:
	  modifies con
	  ensures "a : con";
	*/
	{
		if (!member(a)) {
			Object tmp = data;
			data = a;
			// "con" := "(old con \<setminus> {tmp}) Un {a}";
			//: "con" := "(con \<setminus> {tmp}) Un {a}";
			// "con" := "(old con \<setminus> {old data}) Un {a}";
			// assume "False";
		}
		else { 
			//: assume "False"; 
		}
	}

    private boolean member1(Object o1)
    /*:
        ensures "result = (o1 : con)"
    */
    {
        Node current = this;
        while /*: inv "current : Node & current : Object.alloc & 
                       (o1 : con) = (o1 : current..Node.con)" */
            (current != null) {
            if (current.data==o1) {
                return true;
            }
            current = current.next;
        }
        return false;
    }

	public boolean member(Object o)
	/*:
	  ensures "result = (o : con)";
	 */
	{
		return member1(o);
	}
}
