public class DLL
{
   private static Node root;
   
   /*: public static specvar content :: objset;
       private vardefs "content == 
        {x. rtrancl_pt (% x y. Node.next x = y) root x & x ~= null}";
   
       invariant "tree [Node.next]";
   
       invariant "root = null | (ALL n. n..Node.next ~= root)";
   
       invariant "ALL x y. x ~= null & y ~= null & x..Node.next = y --> y : content";

         invariant "ALL x y. Node.prev x = y --> 
                      (x ~= null & (EX z. Node.next z = x) --> Node.next y = x) &
                      (((ALL z. Node.next z ~= x) | x = null) --> y = null)";
//       invariant "ALL x y. Node.prev x = y --> (x ~= null --> Node.next y = x)"; - contradictory

//       invariant "ALL x y. Node.prev x = y --> (y ~= null --> Node.next y = x) & 
//                                               (y = null & x ~= null --> (ALL z. Node.next z ~= x))";

   */   

   public static void addLast(Node p)
      /*: 
	requires "p ~: content & p ~= null"
	modifies content
	ensures "content = old content Un {p}";
      */
   {
      if (root == null) {
        root = p;
        p.next = null; 
        p.prev = null;
        return;
      }

      Node r = root;
      while (r.next != null) {
	 r = r.next;
      }
      r.next = p; 
      p.prev = r;
      p.next = null; 
   }

   public static boolean isEmpty()
   {
       return root == null;
   }
	

   public static void remove(Node n)
      /*: requires "n : content"
        modifies content
        ensures "comment ''elementRemoved'' (content = old content - {n})"
      */
   {
      if (n==root) {
	 root = root.next;
      } else {
	 n.prev.next = n.next;
      }
      if (n.next != null) {
	 n.next.prev = n.prev;
      }
      n.next = null;
      n.prev = null;
   }

   public static void removeBroken(Node n)
      /*: requires "n : content & n ~= null"
        modifies content
        ensures "True";
      */
   {
       /*: noteThat invsImply: "ALL y. y ~= null & y ~: content --> 
                                       Node.prev y = null"; */
       //: assume "n ~= root";
       //: assume "root ~= null";
       Node np = n.prev;
       Node nn = n.next;
       //: assert aha: "Node.next np = n";
       //: assert ofCourse: "Node.next n = nn";
       //: assume "np ~= null";
       //: assume "nn = null";
       //: assert list1: "np ~= n & nn ~= n";
       np.next = nn;
       //: assert shrinks: "content \<subseteq> old content";
       //: assert "tree[Node.next]";
       //: noteThat "ALL x. Node.next x ~= n";
       //: assert notin: "n ~: content"; // THIS FAILS
       //: assume "False";
   }

    private static void mystery(Node n) // this one works
      /*: 
        ensures "True";
      */
    {
        //: assume "tree [Node.next]";
        //: assume "ALL x. Node.next x ~= n";
        //: assume "n ~= root";
        //: assert "n ~: content";
        //: assume "False";
    }

    public static void driver()
    /*: requires "content = {}"
      ensures "True";
    */
    {
	int i = 0;
	int m = 11;
	Node[] saved = new Node[m];
	boolean b;

	while (i < m) {
	    Node n = new Node();
	    addLast(n);
	    b = isEmpty();
	    //: assert "~b";
	    saved[i] = n;
	    i = i + 1;
	}
	i = 0;
	while (i < m) {
	    remove(saved[i]);
	    i = i + 1;
	}
	b = isEmpty();
	//: assert "b";
    }
}
